<?php
if (!defined('ABSPATH')) {
    exit;
}

if(class_exists('Helpers') != true) {
    class Helpers
    {
        public static function formatPrice($pret, $numar = 1, $rataconversie = 1) {
            if($pret == '') {
                return '';
            } else {
                if (empty($rataconversie) || $rataconversie == 0) {
                    $rataconversie = 1;
                }
                return round((floatval(self::clearpret($pret)) * $rataconversie * $numar), 2);
            }
        }
        private static function clearpret($pret) {
            return str_replace("US $", "", $pret);
        }
    }
}

if(class_exists('TextSpinner') != true) {
    class TextSpinner
    {
        private static $_instance;

        private $_file;
        private $_data;
        private $_found;

        private function __construct($lang = "en")
        {
            $this->_file = $this->getFile($lang);
        }

        public function spin($data, $maxWordsToSpin = 0)
        {
            $maxWordsToSpin = intval($maxWordsToSpin);
            $this->_found = array();
            $this->_data = $data;
            $htmlTags = $this->extract("/<[^<>]+>/is");
            $shortCodes = $this->extract("/\[.*?\]/s");
            $tagsToExclude = array_merge($ht, $sc);
            foreach ($tagsToExclude as $tag) {
                $this->_data = str_replace($tag, '(' . md5($tag) . ')', $this->_data);
            }

            foreach ($this->_file as $line) {
                $this->analyzeLine($line);
                if($maxWordsToSpin != 0 && count($this->_found) >= $maxWordsToSpin) {
                    break;
                }
            }

            foreach ($tto as $tag) {
                $this->_data = str_replace('(' . md5($tag) . ')', $tag, $this->_data);
            }

            if (count($this->_found) != 0) {
                foreach ($this->_found as $key => $val) {
                    $this->_data = str_replace($key, " " . $val, $this->_data);
                }
            }

            return $this->_data;
        }

        public function getData()
        {
            return $this->_data;
        }



        public static function getInstance()
        {
            if (!self::$_instance) {
                self::$_instance = new self();
            }

            return self::$_instance;
        }


        private function extract($pattern)
        {
            $matches = array();
            preg_match_all($pattern, $this->_data, $matches, PREG_PATTERN_ORDER);
            return $matches[0];
        }

        private function getFile($lang)
        {
            return file(dirname(__FILE__) . "/xpressstores_" . $lang . "_data.txt");
        }

        private function analyzeLine($line)
        {
            $synonyms = explode('|', $line);

            $cnt = count($synonyms);
            for ($i = 0; $i < $cnt; $i++) {
                $cuvant = $synonyms[$i];
                if ($this->analyzecuvant($cuvant)) {
                    $rand = $i;
                    while ($rand == $i) {
                        $rand = rand(0, $cnt - 1);
                    }

                    $cuvantnou = $synonyms[$rand];
                    $firstChar = substr($cuvantnou, 0, 1);
                    if (ctype_upper($firstChar) || is_int($firstChar)) {
                        $this->replacecuvant($cuvant, $cuvantnou);
                    } else {
                        $this->replacecuvant($cuvant, $cuvantnou, true);

                        if (!is_numeric($cuvant)) {
                            $cuvant = ucfirst($cuvant);
                            $cuvantnou = ucfirst($cuvantnou);
                            $this->replacecuvant($cuvant, $cuvantnou);
                        }
                    }

                    break;
                }
            }
        }

        private function replacecuvant($cuvantvechi, $cuvantnou, $cuvantsenitiv = false)
        {
            $md5w = md5($cuvantvechi);
            $this->_found[$md5w] = str_replace(array("\n", "\r"), '', $cuvantnou);
            $pattern = '/\b\s' . $cuvantvechi . '\b/' . ($cuvantsenitiv ? 'u' : 'i');
            $this->_data = preg_replace($pattern, $md5w, $this->_data);
        }
		private function analyzecuvant($cuvant)
        {
            if (trim($cuvant) != '') {
                $cuvant2 = str_replace('/', '\/', $cuvant);
                return preg_match('/\b\s' . $cuvant2 . '\b/i', $this->_data);
            }
        }
    }
}

Class HTTPTranslator {
    function curlRequest($url, $authHeader) {
        $ch = curl_init();
        curl_setopt ($ch, CURLOPT_URL, $url);
        curl_setopt ($ch, CURLOPT_HTTPHEADER, array($authHeader,"Content-Type: text/xml"));
        curl_setopt ($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, False);
        $curlResponse = curl_exec($ch);
        $curlErrno = curl_errno($ch);
        if ($curlErrno) {
            $curlError = curl_error($ch);
            throw new Exception($curlError);
        }
        curl_close($ch);
		//print_r($curlResponse);
        return $curlResponse;
    }
}
class XpressstoresCampaign {   
  
    var $id = 0; 
    var $name;
    var $description;
    var $pricefrom;
    var $priceto;
    var $salesfrom;
    var $salesto;
    var $commissionfrom;
    var $commissionto;
    var $ali_category;
    var $dest_category;
    var $publish_type;
    var $cron_schedule;
    var $keywords;
    var $days_active;
    var $num_products;
    var $active;

    public function listCampaigns() {
        global $wpdb;     
        $campaigns = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix . "xpressstores_campaigns ORDER BY ID DESC");return $campaigns;
    }

    public function getCampaignById($id) {
        global $wpdb;             
        
        $query = "SELECT * FROM " . $wpdb->prefix . "xpressstores_campaigns WHERE `id` = '%d'";        
        $result = $wpdb->get_row( $wpdb->prepare( $query, $id ));      
		//print_r($result);
        return $result;
    }

    public function save()
    {
         global $wpdb;
			if ($this->id > 0) {	                    
	           return $wpdb->update(                
                    $wpdb->prefix . 'xpressstores_campaigns', array(
		                'name' => $this->name,
		                'description' => $this->description,
                        'pricefrom' => $this->pricefrom,
                        'priceto' => $this->priceto,
                        'commissionfrom' => $this->commissionfrom,
                        'commissionto' => $this->commissionto,
                        'salesfrom' => $this->salesfrom,
                        'salesto' => $this->salesto,
                        'keywords' => $this->keywords,
                        'publish_type' => $this->publish_type,
                        'days_active' => $this->days_active,
                        'ali_category' => $this->ali_category,
                        'cron_schedule' => $this->cron_schedule,
                        'dest_category' => $this->dest_category,
                        'num_products' => $this->num_products,
		                'active' => $this->active
                    ), array('id' => $this->id)
	            );
	        } else {
	        
	         $res = $wpdb->insert(
	                $wpdb->prefix . 'xpressstores_campaigns', array(
	                    'created_on' => date("Y-m-d H:i:s"),
		                'name' => $this->name,
		                'description' => $this->description,
                        'pricefrom' => $this->pricefrom,
                        'priceto' => $this->priceto,
                        'commissionfrom' => $this->commissionfrom,
                        'commissionto' => $this->commissionto,
                        'salesfrom' => $this->salesfrom,
                        'salesto' => $this->salesto,
                        'keywords' => $this->keywords,
                        'publish_type' => $this->publish_type,
                        'days_active' => $this->days_active,
                        'ali_category' => $this->ali_category,
                        'cron_schedule' => $this->cron_schedule,
                        'dest_category' => $this->dest_category,
                        'num_products' => $this->num_products,
		                'active' => $this->active
	                )
	            );           
                return $wpdb->insert_id;   
	        }			
    }

    public function delete($id)
    {
        global $wpdb;
        $result = $wpdb->delete($wpdb->prefix . "xpressstores_campaigns", array( 'id' => $id ) );
        return $result;
    }
}

class AccessTokenAuthentication {
    function getTokens($grantType, $scopeUrl, $clientID, $clientSecret, $authUrl){
        try {
            $ch = curl_init();
            $paramArr = array (
                 'grant_type'    => $grantType,
                 'scope'         => $scopeUrl,
                 'client_id'     => $clientID,
                 'client_secret' => $clientSecret
            );
            $paramArr = http_build_query($paramArr);
            curl_setopt($ch, CURLOPT_URL, $authUrl);
            curl_setopt($ch, CURLOPT_POST, TRUE);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $paramArr);
            curl_setopt ($ch, CURLOPT_RETURNTRANSFER, TRUE);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            $strResponse = curl_exec($ch);
            $curlErrno = curl_errno($ch);
            if($curlErrno){
                $curlError = curl_error($ch);
                throw new Exception($curlError);
            }
            curl_close($ch);
            $objResponse = json_decode($strResponse);
            if (isset($objResponse->error)){
                throw new Exception($objResponse->error_description);
            }
            return $objResponse->access_token;
        } catch (Exception $e) {
            echo "Exception-".$e->getMessage();
        }
    }
}
if(class_exists('Configuration') == false) {    
    class Configuration
    {
        public static $numOfWordsToSpinOption = array(0 => 'All possible', 10 => '10', 20 => '20', 50 => '50');
        public static $templateOption = array(
            1 => 'List',
            2 => 'Banner',
            3 => 'Image and Text',
            4 => 'Text Link');
    }
}


class Xpressstores {
    private static $initialized = false;
    
    public static function init() {
        if(!self::$initialized) {
            self::init_hooks();
        }
    }    
    public static function init_hooks() {
        self::$initialized = true;
         wp_enqueue_style('xpressstores_wp_public_template_css', plugins_url('css/admin-template.css', __FILE__));				
        self::frontp();
    }   
    public static function frontp() {       
        add_action('wp_head', array('Xpressstores', 'post_view_counter_add'), 0);    
        $rali = (isset($_REQUEST['redirectAli']) && $_REQUEST['redirectAli']) != '' ? $_REQUEST['redirectAli'] : '';       
           
        if( isset($rali) && trim($rali)!=="") 
        {
            self::redirect_toali($rali);            
        }
        add_shortcode( 'xpressstores', array('Xpressstores','addpshortcodes'));
        add_shortcode( 'xpressstores_template', array('Xpressstores','add-product-shortcode-template'));
    }

    public static function addpshortcodes( $atributes) {
      $pid = isset($atributes['id']) ? esc_attr($atributes['id']):0;
      $width = isset($atributes['width']) ? esc_attr($atributes['width']):100;
      ob_start();     
      $p = get_post($pid);
        if (!empty($p)) {          
            $url = get_post_meta($p->ID, '_product_url', true);
            echo '<a class="xpressstores_banner" href="'.esc_url($url).'" title="'.esc_attr($p->subject).'">';
            echo get_the_post_thumbnail( $p->ID, array($width, $width));
            echo '</a>';
        }
      $output = ob_get_contents();
      ob_end_clean();
      return $output;
    }

    public static function addpshortcodes_template($atributes) {
        $pid = isset($atributes['productid']) ? intval($atributes['productid']) : 0;
        $template = isset($atributes['template']) ? intval($atributes['template']) : 1;

        ob_start();

        $p = get_post($pid);

        if (!empty($p)) {            
            $url = get_post_meta($p->ID, '_product_url', true);
            switch($template) {
                case 1: 
                echo '<div class="xpressstores_list_item">';
                 echo '<a class="xpressstores_list_item_text" href="'.esc_url($url).'" title="'.esc_attr($p->post_title).'">';
                    echo esc_attr($p->post_title);
                    echo '</a>';
                    echo get_the_post_thumbnail( $p->ID, 'medium');
                echo '</div>';
                    break;
                case 2: 
                    echo '<a class="xpressstores_banner" href="'.esc_url($url).'" title="'.esc_attr($p->post_title).'">';
                    echo get_the_post_thumbnail( $p->ID, 'medium');
                    echo '</a>';
                    break;
                case 3: 
                    echo '<p>'.esc_attr($p->subject).'</p>';
                    echo '<a class="xpressstores_linktext" href="'.esc_url($url).'" title="'.esc_attr($p->post_title).'">';
                    echo get_the_post_thumbnail( $p->ID, 'medium');
                    echo '</a>';
                    break;
                case 4: 
                    echo '<a class="xpressstores_text" href="'.esc_url($url).'" title="'.esc_attr($p->post_title).'">';
                    echo esc_attr($p->post_title);
                    echo '</a>';
                    break;
            }        
        }

        $output = ob_get_contents();
        ob_end_clean();
        return $output;
    }

    public static function post_view_counter_add()
    {       
        if (is_admin()) {return;}
        if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
                return;
        if ( defined( 'DOING_AJAX' ) && DOING_AJAX ) 
                return;

        global $post;
             if(!is_single()) {return;}
           if(!isset($post) || !is_int($post->ID)) {return;}
         if ( current_user_can('manage_options') ){return;}
        $bots = 'Google|msnbot|Rambler|Yahoo|AbachoBOT|accoona|AcioRobot|ASPSeek|CocoCrawler|Dumbot|FAST-WebCrawler|GeonaBot|Gigabot|Lycos|MSRBOT|Scooter|AltaVista|IDBot|eStyle|Scrubby';
        if ( strpos($bots , $_SERVER['HTTP_USER_AGENT']) === true ){return;}
        if ( false !== wp_is_post_revision($post->ID) )
                return;
           $hits = (int) get_post_meta($post->ID, '_ali_hits', true);        
        update_post_meta($post->ID, '_ali_hits', (int)($hits+1));     
    }
    public static function redirect_toali($rali = '') {
        $query = new WP_Query(array('post_type' => 'product', 'meta_key'=>'_product_url', 'meta_value' => home_url('/?redirectAli='.$rali)));
        $post = $query->get_posts();
    
        if (is_array($post) && !empty($post) && isset($post[0])) 
        {
            $post = $post[0]; 

            $hits = (int) get_post_meta($post->ID, '_ali_redirects', true);
            update_post_meta($post->ID, '_ali_redirects', (int)($hits+1));
        }	
        else
        {
        }         
        if (strpos($rali, 's.click.aliexpress.com/e/') !== FALSE)
        {
            wp_redirect($rali);
        }
        else{
            wp_redirect($rali);
            //wp_redirect("http://s.click.aliexpress.com/e/".$rali);
        }
        
        exit();
    } 
}

class XpressstoresThemes {
	public function xtheme() {
		$theme = 'light';
		return $theme;
	}
}

class XpressstoresReTarget {   
    public function listXpressstoresReTarget() {
        global $wpdb;     
        $targetare = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."xpressstores_target");
		return $targetare;
    }
	public function rsave()
    {
        global $wpdb;
		return $wpdb->update(                
			$wpdb->prefix . 'xpressstores_target', array(
				'option_value' => $this->option_value
			), array('option_name' => 'CONF_SCRIPT_CODE')
		);
	}
}


class Xpressstores_Admin {

    private static $jquery_cdn_url;

    private static $jquery_local_url;

    private static $aliBaseUrl;

    private static $aliProductsListBaseUrl;

    private static $aliDetailsBaseUrl;

    private static $licUrlHost;

    private static $aliProductParseUrl;

    private static $initialized = false;

    private static $errorCodes = array();

    private static $secretKey = "547866afde48c0.48252358";

    private static $accessToken;



    public static function init() {

        if(!self::$initialized) {

            self::$initialized = true;

            self::$aliBaseUrl = "http://gw.api.alibaba.com/openapi/param2/2/portals.open/";

            self::$aliProductsListBaseUrl = self::$aliBaseUrl . "api.listPromotionProduct/";

            self::$aliDetailsBaseUrl = self::$aliBaseUrl . "api.getPromotionProductDetail/";

            self::$aliProductParseUrl = "http://www.aliexpress.com/item/1/#PRODUCT_ID#.html";

            self::$licUrlHost = 'http://aliffiliate.com';

            self::$errorCodes = array(

                '20030000' => 'Required parameters',

                '20030010' => 'Keyword input parameter error',

                '20030020' => 'Category ID input parameter error or formatting errors',

                '20,030,030' => 'commission rate input parameter error or formatting errors',

                '20030040' => 'Unit input parameter error or formatting errors',

                '20030050' => '30 days promotion amount input parameter error or formatting errors',

                '20,030,060' => 'tracking ID input parameter error or limited length',

                '20030070' => 'unauthorized transfer request',

                '20020000' => 'System Error',

                '20010000' => 'call succeeds',

                '20130000' => 'input parameter Product ID is error',

                '20130010' => 'Tracking ID is error or invalid',

                '20130020' => 'Unauthorized Request',

                '20120000' => 'System error',

                '20110000' => 'Success'

            );



            self::init_hooks();

        }

    }

    public static function init_hooks(){

        add_action('admin_enqueue_scripts', array('Xpressstores_Admin', 'load_resources') );

        add_action('admin_menu', array('Xpressstores_Admin', 'load_menu'));

        add_action('wp_ajax_aliexpress_json', array('Xpressstores_Admin', 'aliexpress_json_callback'));

        add_action('wp_ajax_xpressstores_bulk', array('Xpressstores_Admin', 'xpressstores_bulk_callback'));

        add_action('wp_ajax_xpressstores_import', array('Xpressstores_Admin', 'xpressstores_import_callback'));

        add_action('wp_ajax_xpressstores_translate', array('Xpressstores_Admin', 'xpressstores_translate_callback'));

    }

    public static function formaAli($post, $args) {

        include_once('views/postmeta.php');

    }

    public static function checkLicense()        {

        // The Secret key



        $key = get_option('xpressstores_license_key');

        if (empty($key)) return;



        $data = array ();

        $data['secret_key'] = self::$secretKey;

        $data['slm_action'] = 'slm_check';

        $data['license_key'] = $key;



        // send data to API post URL

        $ch = curl_init (self::$licUrlHost);

        curl_setopt ($ch, CURLOPT_POST, true);

        curl_setopt ($ch, CURLOPT_POSTFIELDS, $data);

        curl_setopt ($ch, CURLOPT_RETURNTRANSFER, true);

        $returnValue = curl_exec ($ch);
//print_r($returnValue);


        if (isset($returnValue) && $returnValue->result == 'success' && $returnValue->message == 'active')

        {



        }

        else

        {

            if (($returnValue->result == 'success' && $returnValue->message != 'active') || $returnValue->result == 'error')

            {

                update_option('xpressstores_license_key', '');

            }

        }

    }

    public static function load_resources($hook) {

        if (strpos($hook, 'xpressstores') === false) {

            return;

        }

		// css

        wp_enqueue_style('xpressstores_wp_admin_css', plugins_url('css/admin.css', __FILE__));

		wp_enqueue_style('xpressstores_wp_admin_xpress_css', plugins_url('css/xpress-style.css', __FILE__));

		wp_enqueue_style('xpressstores_wp_admin_xpress_boot_css', plugins_url('css/bootstrap.min.css', __FILE__));

		wp_enqueue_style('xpressstores_wp_admin_xpress_tab_css', plugins_url('css/tabModule.css', __FILE__));

		wp_enqueue_style('xpressstores_wp_admin_xpress_fonts_css', plugins_url('css/font-awesome.min.css', __FILE__));

		wp_enqueue_style('xpressstores_wp_admin_jquery_ui_css', plugins_url('css/jquery-ui.min.css', __FILE__));

		

		wp_enqueue_style("wp-jquery-ui-dialog");

        wp_enqueue_script('jquery');

        wp_enqueue_script('jquery-ui-core');

        wp_enqueue_script('jquery-ui-dialog');



		//wp_enqueue_script('xpressstores_wp_admin_js_xpressstores', plugins_url('js/jquery-1.11.1.js', __FILE__));

        wp_enqueue_script('xpressstores_wp_admin_js_xpressstores', plugins_url('js/xpressstores.js', __FILE__));

        wp_enqueue_script('xpressstores_wp_admin_js_datatables', plugins_url('js/jquery.dataTables.min.js', __FILE__));

        wp_enqueue_script('xpressstores_wp_admin_js_validation', plugins_url('js/jquery.validate.min.js', __FILE__));

		wp_enqueue_script('xpressstores_wp_admin_js_tab', plugins_url('js/tabModule.js', __FILE__));

        wp_enqueue_script('xpressstores_wp_admin_boot_js_validation', plugins_url('js/bootstrap.min.js', __FILE__));

		wp_enqueue_script('xpressstores_wp_admin_boot_js_validation', plugins_url('js/slider.range-xpress.js', __FILE__));

		//wp_enqueue_script('xpressstores_wp_admin_range_js', plugins_url('js/jquery.mobile-1.4.5.min.js', __FILE__));

        //wp_enqueue_script('xpressstores_wp_admin_js_jquery_ui', plugins_url('js/jquery-ui.min.js', __FILE__));

        wp_enqueue_script('xpressstores_wp_admin_js_circle', plugins_url('js/circle-progress.js', __FILE__));

    }

    public static function load_menu() {



        if (true)

        {

            add_menu_page('Xpress Stores Dashboard', 'Xpress Stores', 'manage_options', 'xpressstores-dashboard', array('Xpressstores_Admin', 'display_dashboard_page'), plugins_url( 'images/xpress-icon.png', __FILE__));



            add_submenu_page('xpressstores-dashboard', 'Xpress Stores - Dashboard', 'Dashboard', 'manage_options', 'xpressstores-dashboard', array('Xpressstores_Admin', 'display_dashboard_page'));



            add_submenu_page('xpressstores-dashboard', 'Xpress Stores - Settings', 'Settings', 'manage_options', 'xpressstores-settings', array('Xpressstores_Admin', 'display_settings_page'));



            add_submenu_page('xpressstores-dashboard', 'Xpress Stores - Bulk Import', 'Bulk Import', 'manage_options', 'xpressstores-bulk', array('Xpressstores_Admin', 'display_bulk_page'));

            add_submenu_page('xpressstores-dashboard', 'Xpress Stores - Manual Import', 'Manual Import', 'manage_options', 'xpressstores-import', array('Xpressstores_Admin', 'display_import_page'));



            add_submenu_page('xpressstores-dashboard', 'Xpress Stores - Campaigns', 'Campaigns', 'manage_options', 'xpressstores-campaigns', array('Xpressstores_Admin', 'display_campaigns_page'));
			
			add_submenu_page('xpressstores-dashboard', 'Xpress Stores - Themes', 'Themes', 'manage_options', 'xpressstores-themes', array('Xpressstores_Admin', 'display_theme_page'));
			

			add_submenu_page('xpressstores-dashboard', 'ReTarget Code - Campaigns', 'target', 'manage_options', 'xpressstores-retarget', array('Xpressstores_Admin', 'display_retarget_page'));



            $post_types = get_post_types();

            foreach ( $post_types as $post_type ) {

                //echo $post_type;

                add_meta_box( 'aliffiliateProduct', 'Add Xpress Stores Product', array('Xpressstores_Admin','formaAli'), $post_type, 'normal' );

            }

        }

        else

        {

            add_menu_page('Xpressstores Activation', 'Xpressstores', 'manage_options', 'xpressstores-dashboard', array('Xpressstores_Admin', 'display_activate_page'), plugins_url( 'images/xpress-icon.png', __FILE__));

        }

    }

    public static function view($name, array $args = array()) {

        foreach ( $args AS $key => $val ) {

            $$key = $val;

        }

        $file = XPRESSSTORES__PLUGIN_DIR . 'views/' . $name . '.php';

        include( $file );

    }

    public static function display_dashboard_page() {
		
        if (isset($_GET['post']) && $_GET['post']!="") {

            $post_id = $_GET['post'];



            if ($_GET['action']=='trash') {

                if ( $user_id = wp_check_post_lock( $post_id ) ) {

                    $user = get_userdata( $user_id );

                    wp_die( sprintf( __( 'You cannot move this item to the Trash. %s is currently editing.' ), $user->display_name ) );

                }

                if ( ! wp_trash_post( $post_id ) )

                    echo( 'Error in moving to Trash.' );

            } else if ($_GET['action']=='translate') {

                Xpressstores_Admin::translateProduct($post_id);

                $redurl = remove_query_arg( array('post', 'action'));

            }

        }



        wp_enqueue_script('xpressstores_wp_admin_js_dashboard', plugins_url('js/dashboard.js', __FILE__));



        $posts = get_posts(array(

            'post_type' 	=> 'product',

            'numberposts' 	=> -1,

            'no_found_rows' => true,

            'orderby'       => 'ID',

            'order'         => 'DESC',

            'post_status'   => 'any'

        ));

        $args = array();

        $args['posts'] = $posts;

        Xpressstores_Admin::view('dashboard', $args);

    }

	public static function display_theme_page() {

		 $args = array();
		 Xpressstores_Admin::view('themes', $args);
	}

	public static function display_retarget_page() {



        $retargetcode = new XpressstoresReTarget();

		

		$retarget = $retargetcode->listXpressstoresReTarget();

		if(isset($_POST['save'])) {

			$retargetcode->option_name = 'CONF_SCRIPT_CODE';

			$retargetcode->option_value = isset($_POST['targetdes'])?$_POST['targetdes']:"";

			$res = $retargetcode->rsave();

		}

		

        $args = array();

        $args['retarget'] = $retarget;

        Xpressstores_Admin::view('retarget', $args);

	}

	

    public static function display_campaigns_page() {



        $campaign = new XpressstoresCampaign();

        if(isset($_POST['save'])) {



            $campaign->id = isset($_POST['id'])?$_POST['id']:"";

            $campaign->name = isset($_POST['name'])?$_POST['name']:"";

            $campaign->description = '';//isset($_POST['aiEnableAuto'])?$_POST['aiEnableAuto']:"";

            $campaign->pricefrom = isset($_POST['pricefrom'])?$_POST['pricefrom']:"";

            $campaign->priceto = isset($_POST['priceto'])?$_POST['priceto']:"";

            $campaign->commissionfrom = isset($_POST['commissionfrom'])?$_POST['commissionfrom']:"";

            $campaign->commissionto= isset($_POST['commissionto'])?$_POST['commissionto']:"";

            $campaign->salesfrom= isset($_POST['salesfrom'])?$_POST['salesfrom']:"";

            $campaign->salesto= isset($_POST['salesto'])?$_POST['salesto']:"";

            $campaign->keywords= isset($_POST['keywords'])?$_POST['keywords']:"";

            $campaign->publish_type= isset($_POST['publish_type'])?$_POST['publish_type']:"draft";

            $campaign->days_active= isset($_POST['days_active'])?$_POST['days_active']:"0";

            $campaign->ali_category= isset($_POST['ali_category'])?$_POST['ali_category']:"0";

            $campaign->cron_schedule=isset($_POST['cron_schedule'])?$_POST['cron_schedule']:"daily";

            $campaign->dest_category= isset($_POST['dest_category'])?$_POST['dest_category']:"0";

            $campaign->num_products= isset($_POST['num_products'])?$_POST['num_products']:"5";

            $campaign->active = isset($_POST['active'])?$_POST['active']:0;



            $res = $campaign->save();



            if ($campaign->id > 0)

            {

                $campid = $campaign->id ;

            }

            else

            {

                if ($res>0)

                {

                    $campid = $res;

                }

                else

                    $campid = 0;

            }



            if ($campaign->active == 1)

            {

                Xpressstores_Admin::removeCampaignSchedule($campid);

                Xpressstores_Admin::set_campaign_schedule($campid, $campaign->cron_schedule);

            }

            else

            {

                if ($campaign->id > 0)

                {

                    Xpressstores_Admin::removeCampaignSchedule($campid);

                }

            }



        }

        //die();

        if(isset($_POST['edit'])) {

            $id = $_POST['id'];

            self::display_campaign_edit_page($id);

            exit();

        }

        if(isset($_POST['new'])) {

            self::display_campaign_edit_page(0);

            exit();



        }

        if(isset($_POST['delete'])) {

            $id = $_POST['id'];

            Xpressstores_Admin::removeCampaignSchedule($id);

            $res = $campaign->delete($id);

        }



        $campaigns = $campaign->listCampaigns();



        $args = array();

        $args['campaigns'] = $campaigns;

        Xpressstores_Admin::view('campaigns', $args);



    }

    public static function display_campaign_edit_page($id) {



        $model = new XpressstoresCampaign();

        if ($id>0)

            $campaign = $model->getCampaignById($id);

        else

            $campaign = $model;

        $args = array();

        $args['campaign'] = $campaign;

        Xpressstores_Admin::view('newcampaign', $args);

    }

    public static function translate($texttotranslate)        {

        try {

            //Client ID of the application.

            $clientID       = "aliffiliate1";

            //Client Secret key of the application.

            $clientSecret = "punyW01nfQ6svDQ7jSUrDWwLNwXU33W0snuWkUQH4F8=";

            //OAuth Url.

            $authUrl      = "https://datamarket.accesscontrol.windows.net/v2/OAuth2-13/";

            //Application Scope Url

            $scopeUrl     = "http://api.microsofttranslator.com";

            //Application grant type

            $grantType    = "client_credentials";



            //if (empty(self::$accessToken))

            {

                //Create the AccessTokenAuthentication object.

                $authObj      = new AccessTokenAuthentication();

                //Get the Access token.

                $accessToken  = $authObj->getTokens($grantType, $scopeUrl, $clientID, $clientSecret, $authUrl);

                //Create the authorization Header string.

            }



            $authHeader = "Authorization: Bearer ". $accessToken;



            $settings = get_option('xpressstores_settings');

            if (empty($settings["lang_translate"])) return "";

            //Set the params.//

            $fromLanguage = "en";

            $toLanguage   = $settings["lang_translate"];

            $inputStr     = $texttotranslate;

            $contentType  = 'text/html';

            $category     = 'general';



            $params = "text=".urlencode($inputStr)."&to=".$toLanguage."&from=".$fromLanguage."&contentType=".urlencode( $contentType);

            $translateUrl = "http://api.microsofttranslator.com/v2/Http.svc/Translate?$params";



            //Create the Translator Object.

            $translatorObj = new HTTPTranslator();



            //Get the curlResponse.

            $curlResponse = $translatorObj->curlRequest($translateUrl, $authHeader);


			$translatedStr='';
            //Interprets a string of XML into an object.

            $xmlObj = simplexml_load_string($curlResponse);

            foreach((array)$xmlObj[0] as $val){

                $translatedStr = $val;

            }



            return $translatedStr;



        } catch (Exception $e) {

            return "";

            echo "Exception: " . $e->getMessage() . PHP_EOL;

        }

    }

    public static function replacetag($tag, $result, $content, $direction)        {

        $cnt = 0;

        if ($direction)

        {

            foreach($result as $m)

            {

                $content = str_replace($m, "($tag(".$cnt.")$tag)", $content);

                $cnt++;

            }

        }

        else

        {

            foreach($result as $m)

            {

                $content = str_replace("($tag(".$cnt.")$tag)", $m,$content);

                $cnt++;

            }

        }



        return $content;

    }

    public static function translateProduct($productId)        {

        $settings = get_option('xpressstores_settings');

        if (empty($settings["lang_translate"])) return "";



        $product = get_post($productId);






        $content = $product->post_content;

        

		preg_match_all('/<img[^>]+>/i',$content, $result);



        $res = self::replacetag("i", $result[0], $content, TRUE);



        $regexp = "<a\s[^>]*href=(\"??)([^\" >]*?)\\1[^>]*>(.*)<\/a>";

        preg_match_all("/$regexp/siU", $res, $linkmatches);



        $res = self::replacetag("a", $linkmatches[0], $res, TRUE);

        $res = preg_replace("/<([a-z][a-z0-9]*)[^>]*?(\/?)>/i",'<$1$2>', $res);



        $title = self::translate($product->post_title);

        $desc = self::translate($res);



        $res = self::replacetag("a", $linkmatches[0], $desc, FALSE);

        $res = self::replacetag("i", $result[0], $res, FALSE);



        $updated = array();

        $updated['ID'] = $productId;

        if (!empty($res)) $updated['post_content'] = $res;

        if (!empty($title)) $updated['post_title'] = $title;



        if (!empty($res) && !empty($title))

        {

            wp_update_post( $updated );

            update_post_meta($productId, '_translated', '1');

        }

    }

    public function scheduleSync($freq){

        if( !wp_next_scheduled('xpressstores_sync')) {

            $res= wp_schedule_event(time()+60*60*5, $freq, 'xpressstores_sync');

        }

    }

    /*public function  removeScheduleSync(){

        $res = wp_clear_scheduled_hook( 'xpressstores_sync');

    }*/
	public function removeScheduleSync(){

        $res = wp_clear_scheduled_hook( 'xpressstores_sync');

    }
    public function autoImport($settings){

        if(!wp_next_scheduled('xpressstores_auto')) {

            wp_schedule_event(time()+60*60, /*'hourly'*/$settings['ai_freq']/**/,  'xpressstores_auto');

        }

    }

    public static function set_campaign_schedule($campaign_id, $reccurence) {

        $time = time()+60*60*6;

        $args = array('campaign_id' => intval($campaign_id));

        wp_schedule_event( $time, $reccurence, 'xpressstores_auto_campaign', $args);

    }

    public static function removeCampaignSchedule($campaign_id){

        $args = array('campaign_id' => $campaign_id);

        wp_clear_scheduled_hook('xpressstores_auto_campaign', $args);



        $args = array('campaign_id' => intval($campaign_id));

        wp_clear_scheduled_hook('xpressstores_auto_campaign', $args);

    }

    public function removeautoImport(){

        wp_clear_scheduled_hook('xpressstores_auto');

    }

    public static function display_settings_page() {

        if(isset($_POST['save'])) {

            $settings = array(

                'api_key' =>isset($_POST['afApiKey'])?$_POST['afApiKey']:"",

                'digital_signature' => isset($_POST['afDigitalSignature'])?$_POST['afDigitalSignature']:"",

                'tracking_id' => isset($_POST['afTrackingId'])?$_POST['afTrackingId']:"",

                'page_size' => isset($_POST['afPageSize'])?$_POST['afPageSize']:"",

                'post_type' => isset($_POST['afPost_type'])?$_POST['afPost_type']:"",

                'sync_freq' => isset($_POST['afSyncFreq'])?$_POST['afSyncFreq']:"",

                'sync_enabled' => isset($_POST['afEnableSync'])?$_POST['afEnableSync']:"",

                'sync_price' => isset($_POST['afSyncPrice'])?$_POST['afSyncPrice']:"",

                'sync_name' => isset($_POST['afSyncName'])?$_POST['afSyncName']:"",

                'sync_desc' => isset($_POST['afSyncDesc'])?$_POST['afSyncDesc']:"",

                'lang_translate' => isset($_POST['afLang'])?$_POST['afLang']:"",

                'buy_redirect' => isset($_POST['afNewTab'])?$_POST['afNewTab']:"",

                'remove_links' => isset($_POST['afRemLinks'])?$_POST['afRemLinks']:"",

                'sync_desc' => isset($_POST['afSyncDesc'])?$_POST['afSyncDesc']:"",

                'spin_text' => isset($_POST['afEnableTextSpin']) ? $_POST['afEnableTextSpin'] : '',

                'spin_text_words' => isset($_POST['afSpinTextWords']) ? $_POST['afSpinTextWords'] : 0,

                'conversion_rate' => isset($_POST['afConversionRate']) ? $_POST['afConversionRate'] : 1

            );



            update_option('xpressstores_settings', $settings);



            if (isset($settings['sync_enabled']) && $settings['sync_enabled']=='sync')

            {

                $freq  = isset($settings['sync_freq'])?$settings['sync_freq']:'daily';

                Xpressstores_Admin::scheduleSync($freq);

            }

            else

            {

                Xpressstores_Admin::removeScheduleSync();

            }

        }



        $settings = get_option('xpressstores_settings');

        $args = array(

            'afApiKey' => isset($settings['api_key'])?$settings['api_key']:"",

            'afDigitalSignature' => isset($settings['digital_signature'])?$settings['digital_signature']:"",

            'afTrackingId' => isset($settings['tracking_id'])?$settings['tracking_id']:"",

            'afPageSize' => isset($settings['page_size'])?$settings['page_size']:"",

            'afPost_type' => isset($settings['post_type'])?$settings['post_type']:"",

            'afSyncFreq' => isset($settings['sync_freq'])?$settings['sync_freq']:"",

            'afEnableSync' => isset($settings['sync_enabled'])?$settings['sync_enabled']:"",

            'afSyncPrice' => isset($settings['sync_price'])?$settings['sync_price']:"",

            'afSyncName' => isset($settings['sync_name'])?$settings['sync_name']:"",

            'afSyncDesc' => isset($settings['sync_desc'])?$settings['sync_desc']:"",

            'afLang' => isset($settings['lang_translate'])?$settings['lang_translate']:"",

            'afNewTab' => isset($settings['buy_redirect'])?$settings['buy_redirect']:"",

            'afRemLinks' => isset($settings['remove_links'])?$settings['remove_links']:"",

            'afConversionRate' => isset($settings['conversion_rate']) ? $settings['conversion_rate'] : 1,

            'afEnableTextSpin' => isset($settings['spin_text']) ? $settings['spin_text'] : '',

            'afSpinTextWords' => isset($settings['spin_text_words']) ? $settings['spin_text_words'] : 0

        );



        Xpressstores_Admin::view('settings', $args);

    }

    public static function display_bulk_page() {



        Xpressstores_Admin::view('bulk');

    }

    public static function display_activate_page() {

        $xpressstores_secret_key = '547866afde49c5.38404977';

        $xpressstores_server_url = 'http://aliffiliate.com';



        if(isset($_POST['save'])) {

            $license_key = $_REQUEST['licKey'];



            // API query parameters

            $api_params = array(

                'slm_action' => 'slm_activate',

                'secret_key' => $xpressstores_secret_key,

                'license_key' => $license_key,

                'registered_domain' => $_SERVER['SERVER_NAME'],

                'item_reference' => urlencode("Aliffiliate"),

            );



            // Send query to the license manager server

            $response = wp_remote_get(add_query_arg($api_params, $xpressstores_server_url), array('timeout' => 20, 'sslverify' => false));



            // Check for error in the response

            if (is_wp_error($response)){

                $message =  "Unexpected Error! The query returned with an error.";

            }



            $license_data = json_decode(wp_remote_retrieve_body($response));



            if($license_data->result == 'success'){//Success was returned for the license activation



                $message = $license_data->message;



                update_option('xpressstores_license_key', $license_key);

            }

            else{

                $message = $license_data->message;

            }

        }



        $args = array();

        $args['message'] = $message;

        Xpressstores_Admin::view('activate', $args);

    }

    public static function display_import_page() {

        global $wpdb;

        $r = $wpdb->get_col($wpdb->prepare("

                        SELECT meta_value FROM {$wpdb->postmeta}

                        WHERE meta_key = %s", '_ali_id'));

        $args = array(

            'importedAliIds' => $r

        );



        Xpressstores_Admin::view('import', $args);

    }

    public static function display_auto_import_page() {

        if(isset($_POST['save'])) {

            $settings = array(

                'enable_auto' => isset($_POST['aiEnableAuto'])?$_POST['aiEnableAuto']:"",

                'ali_category' => $_POST['aiAliCategory'],

                'ai_keyword' => $_POST['aiKeyword'],

                'ai_price_from' => $_POST['aiPriceFrom'],

                'ai_price_to' => $_POST['aiPriceTo'],

                'ai_commission_from' => $_POST['aiCommisionFrom'],

                'post_type' => isset($_POST['aiPostType'])?$_POST['aiPostType']:"",

                'ai_commission_to' => $_POST['aiCommisionTo'],

                'ai_sales_from' => $_POST['aiSalesFrom'],

                'ai_sales_to' => $_POST['aiSalesTo'],

                'ai_category' => isset($_POST['aiCategory'])?$_POST['aiCategory']:"",

                'ai_numprod' => $_POST['aiNumProducts'],

                'ai_freq' => $_POST['aiAutoFreq']



            );



            update_option('xpressstores_autoimport', $settings);



            if (isset($settings['enable_auto']) && $settings['enable_auto']=='auto_enable')

            {

                Xpressstores_Admin::autoImport($settings);

            }

            else

            {

                Xpressstores_Admin::removeautoImport();

            }

        }



        $settings = get_option('xpressstores_autoimport');

        $args = array(

            'aiEnableAuto' => $settings['enable_auto'],

            'aiAliCategory' => $settings['ali_category'],

            'aiKeyword' => $settings['ai_keyword'],

            'aiPriceFrom' => $settings['ai_price_from'],

            'aiPriceTo' => $settings['ai_price_to'],

            'aiCommisionFrom' => $settings['ai_commission_from'],

            'aiPostType' => isset($settings['post_type'])?$settings['post_type']:"",

            'aiCommisionTo' => $settings['ai_commission_to'],

            'aiSalesFrom' => $settings['ai_sales_from'],

            'aiSalesTo' => $settings['ai_sales_to'],

            'aiCategory' => $settings['ai_category'],

            'aiNumProducts' => $settings['ai_numprod'],

            'aiAutoFreq' => $settings['ai_freq']

        );



        Xpressstores_Admin::view('auto-import', $args);

    }

    public static function get_categories() {

        return array(

            '3' =>  'Apparel & Accessories',

            '34' =>  'Automobiles & Motorcycles',

            '1501' => 'Baby Products',

            '66' => 'Beauty & Health',

            '7' => 'Computer & Networking',

            '33' => 'Construction & Real Estate',

            '44' => 'Consumer Electronics',

            '100008578' => 'Customized Products',

            '5' => 'Electrical Equipment & Supplies',

            '502' => 'Electronic Components & Supplies',

            '2' => 'Food',

            '1503' => 'Furniture',

            '200003655' => 'Hair & Accessories',

            '42' => 'Hardware',

            '15' => 'Home & Garden',

            '6' => 'Home Appliances',

            '200003590' => 'Industry & Business',

            '36' => 'Jewelry & Watch',

            '39' => 'Lights & Lighting',

            '1524' => 'Luggage & Bags',

            '21' => 'Office & School Supplies',

            '509' => 'Phones & Telecommunications',

            '30' => 'Security & Protection',

            '322' => 'Shoes',

            '200001075' => 'Special Category',

            '18' => 'Sports & Entertainment',

            '1420' => 'Tools',

            '26' => 'Toys & Hobbies',

            '1511' => 'Watches'

        );

    }

    public static function construct_ali_express_url($type) {

        $settings = get_option('xpressstores_settings');

        $ret = ($type == "list" ? self::$aliProductsListBaseUrl : self::$aliDetailsBaseUrl) . $settings['api_key'];
		
        return $ret;

    }

    public static function aliexpress_json_callback() {
		//print_r($params);
        /*
        foreach ($_POST as $key => $val ) {

                    if($key == 'categoryId' && $val == 0) {

                        $val = '';

                    }



            if($key != 'action' && $val != '') {

                $jsonurl = $jsonurl;

            }

        }
*/


        //$jsonurl = $jsonurl . 'pageSize=' . (isset($settings['page_size']) ? $settings['page_size'] : 20);
		//print_r($_POST);
        $settings = get_option('xpressstores_settings');
		
        $jsonurl = self::construct_ali_express_url("list");
		$params = array();
		
        foreach ($_POST as $key => $value) {
            $params[$key] = $value;
        }
		$params['pageSize']=  isset($settings['page_size']) ? $settings['page_size'] : 20;
        if (!isset($params['fields']) || empty($params['fields'])) {
            $params['fields'] = 'totalResults,productId,productTitle,productUrl,imageUrl,'
        . 'originalPrice,salePrice,discount,evaluateScore,commission,'
                . 'commissionRate,30daysCommission,volume,packageType,'
                . 'lotNum,validTime';
        }
		
        $json = self::request_data($jsonurl,$params);
		
		echo $json;
        die(); 

    }

    public static function xpressstores_translate_callback() {

        if(isset($_POST["products"])) {

            foreach($_POST["products"] as $k => $v) {

                $int = intval($v);

                if($int > 0) {

                    Xpressstores_Admin::translateProduct($int);

                }

            }

        }

    }



    public static function xpressstores_import_callback() {

        $obj='';
        
        if(isset($_POST["products"])) {

            $categoryId = isset($_POST["aiCategory"]) ? intval($_POST["aiCategory"]) : 0;

            foreach($_POST["products"] as $key => $product) {

                $int = intval($product["productId"]);

                if($int > 0) {
					self::addproduct($obj, $categoryId, $product);
                }

            }

        }
        $array = array(

            "Executed" => true

        );



        echo json_encode($array);

        die();

    }

    public static function bulkImport($jsonurl, $categoryId, $pageno, $alreadythere, $numberofprodtoinsert,$params) 
	{

	 
        $jsonurlToExecute = $jsonurl . 'pageNo='.$pageno.'&pageSize=20';



        $cnt = 0;

        $json = self::request_data($jsonurl,$params);

        $obj = json_decode($json, true);



        if (!isset($obj["result"]))

        {

            return $numberofprodtoinsert;

        }



        $posts = $obj["result"]["products"];

        $responseCode = $obj->errorCode;



        foreach($posts as $key => $product)

        {

            if ($numberofprodtoinsert==0) return $cnt;

            $int = intval($product['productId']);



            if($int > 0) {



                if (in_array($int, $alreadythere))

                {

                    continue;

                }



                $obj = self::get_details($int);

                if (isset($obj) && !empty($obj))

                {

                    if(self::addproduct($obj, $categoryId, $product, 'publish')) {

                        array_push($alreadythere, $int);

                    }



                    $numberofprodtoinsert--;

                    $cnt++;



                }

            }

        }

		return $cnt;

     }

    public static function xpressstores_bulk_callback() {



        @ini_set('max_execution_time', 0);

        @set_time_limit(0); // infinte



        $settings = get_option('xpressstores_settings');

        $jsonurl = self::construct_ali_express_url("list");



       /* foreach ($_POST as $key => $val ) {

            if($key != 'aiCategory' && $key != 'toinsert' && $key != 'action' && $val != '') {

                $jsonurl = $jsonurl . $key . '=' . $val . '&';

            }

        }

*/

		$params = array();
        
		//print_r($_POST);
        foreach ($_POST as $key => $value) {
            $params[$key] = $value;
        }
        if (!isset($params['fields']) || empty($params['fields'])) {
            $params['fields'] = 'totalResults,productId,productTitle,productUrl,imageUrl,'
        . 'originalPrice,salePrice,discount,evaluateScore,commission,'
                . 'commissionRate,30daysCommission,volume,packageType,'
                . 'lotNum,validTime';
        }
        // execute 3 imports per call
        //$jsonurl = $jsonurl . 'pageSize=3';

        global $wpdb;

        $alreadythere = $wpdb->get_col($wpdb->prepare("

                        SELECT meta_value FROM {$wpdb->postmeta}

                        WHERE meta_key = %s", '_ali_id'));

        $pageno = isset($_POST['pageNo'])?intval($_POST['pageNo']):1;
        $numberofprodtoinsert = isset($_POST['toinsert'])?intval($_POST['toinsert']):0;
        $aiCategory = isset($_POST['aiCategory'])?intval($_POST['aiCategory']):0;

        $added = self::bulkImport($jsonurl, $aiCategory, $pageno, $alreadythere, $numberofprodtoinsert,$params);

        $array = array(

            "Executed" => true,

            "Added" => $added,

            "Finished" => ($numberofprodtoinsert - intval($added) < 1)

        );

        echo json_encode($array);

        die();

    }

    public static function slugify($text) {

        $text = preg_replace('~[^\\pL\d]+~u', '-', $text);

        $text = trim($text, '-');

        $text = iconv('utf-8', 'us-ascii//TRANSLIT', $text);

        $text = strtolower($text);

        $text = preg_replace('~[^-\w]+~', '', $text);

        if (empty($text))

        {

            return 'n-a';

        }



        return $text;

    }

    public static function parseProduct($productId) {

        include_once 'phpQuery-onefile.php';

        $url = str_replace('#PRODUCT_ID#', intval($productId), self::$aliProductParseUrl);

        $html = file_get_contents($url);

        $doc = phpQuery::newDocument($html);

        $title = $doc['h1.product-name'];



        if(pq($title)->length() > 0) {

            $productInfoPanel = $doc['div#product-info-price-pnl'];



            $originalPriceDiv = $productInfoPanel['dl.product-info-original'];

            $currentPriceDiv = $productInfoPanel['dl.product-info-current'];

            $lowPriceSelector = 'span[itemprop="lowPrice"]';

            $regularPriceSelector = 'span#sku-price';

            $salePriceSelector = 'span#sku-discount-price';

            $descriptionBox = $doc['.ui-box-body'];



            $regularPrice = null;

            $salePrice = null;



            $name = pq($title)->html();

            $description = pq($descriptionBox)->html();



            $hasDiscount = pq($originalPriceDiv)->length() != 0;

            if($hasDiscount) {

                $hasOriginalMinMaxPrice = pq($originalPriceDiv[$lowPriceSelector])->length() != 0;



                $regularPrice = $hasOriginalMinMaxPrice ?

                    pq($originalPriceDiv[$lowPriceSelector])->html() :

                    pq($originalPriceDiv[$regularPriceSelector])->html();



                // cases when no min max price selector but the price is in format 1-2

                $pos = strpos($regularPrice, "-");

                if($pos !== false) {

                    $regularPrice = trim(substr($regularPrice, 0, $pos));

                }



                $hasCurrentMinMaxPrice = pq($currentPriceDiv[$lowPriceSelector])->length() != 0;

                $salePrice = $hasCurrentMinMaxPrice ?

                    pq($currentPriceDiv[$lowPriceSelector])->html() :

                    pq($currentPriceDiv[$salePriceSelector])->html();

            } else {

                $hasCurrentMinMaxPrice = pq($currentPriceDiv[$lowPriceSelector])->length() != 0;

                if($hasCurrentMinMaxPrice) {

                    $regularPrice = pq($currentPriceDiv[$lowPriceSelector])->html();

                } else {

                    $regularPrice = pq($currentPriceDiv[$regularPriceSelector])->html();

                }

                $salePrice = $regularPrice;

            }



            return array(

                'regularPrice' => $regularPrice,

                'salePrice' => $salePrice,

                'description' => $description,

                'name' => $name);

        }

    }

    public static function autoImportProducts( $jsonurl, $pageno, $numberofprodtoinsert=1 , $categoryId=0, $alreadythere, $posttype, $recursions = 1 ){

        $jsonurlToExecute = $jsonurl . 'pageNo='.$pageno.'&pageSize=40';



        $json = self::request_data($jsonurlToExecute);

        $obj = json_decode($json);

        

		if (!isset($obj->result))

        {

            if ($numberofprodtoinsert>0 && $recursions<10)

            {

                self::autoImportProducts( $jsonurl, $pageno+1, $numberofprodtoinsert, $categoryId,$alreadythere,$posttype, $recursions+1);

            }

        }





        $posts = $obj->result->items;

        //echo $obj->result->total;

        $responseCode = $obj->errorCode;



        foreach($posts as $key => $product)

        {

            if ($numberofprodtoinsert==0) return;



            $int = intval($product->productId);



            if($int > 0) {



                if (in_array($int, $alreadythere))

                {

                    continue;

                }



                $obj = self::get_details($int);



                if (isset($obj) && !empty($obj))

                {

                    $product = json_decode(json_encode($product), true);

                    if(self::addproduct($obj, $categoryId, $product, $posttype)) {

                        array_push($alreadythere, $int);

                    }

                    $numberofprodtoinsert--;

                }

            }

        }



        if ($numberofprodtoinsert>0 && $recursions<10)

        {

            self::autoImportProducts( $jsonurl, $pageno+1, $numberofprodtoinsert, $categoryId,$alreadythere,$posttype, $recursions+1);

        }

        else

        {

            die('kraj');

        }

    }

    private static function get_details($productId) {

        $jsonurl = self::construct_ali_express_url("details");
	
		$params = array();
        
		$params['productId'] = $productId;
        
        if (!isset($params['fields']) || empty($params['fields'])) {
            $params['fields'] = 'totalResults,productId,productTitle,productUrl,imageUrl,'
        . 'originalPrice,salePrice,discount,evaluateScore,commission,'
                . 'commissionRate,30daysCommission,volume,packageType,'
                . 'lotNum,validTime';
        }
		
        $json = self::request_data($jsonurl,$params);
		
        $obj = json_decode($json);
		
        if (isset($obj->result))

            return $obj->result;

        else

            return;

    }

    private static function curl($url,$param='') {
		//print_r($url);
		//print_r(http_build_query($param));
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);	
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($param));
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		
        $responce = curl_exec($ch);
		
        curl_close( $ch );
        return $responce;
    } // end curl



    private static function request_data($url,$param='') {

		$response = self::curl($url,$param);
		if( null == $response ) {
			$response = 0;
		}
		
        return $response;
    } // end request_data



    private static function addproduct($prod, $cat, $additionalInfo, $postStatus = ''){

        set_time_limit(60);
        $settings = get_option('xpressstores_settings');
        //if (is_null($prod) || !isset($prod->description)) return false;

        

        //$excerpt = strip_tags($prod->description);

        //$excerpt = trim(substr($excerpt,0 , 200));



        $pstatus = ($postStatus=='' ?$settings['post_type']:$postStatus);

        /*$desctoimport = $prod->description;

        if ($settings['remove_links']=="1")

        {

            $desctoimport = strip_tags($desctoimport, '<h1><h2><h3><h4><i><p><img><b><ul><li><span><br><div>');

        }

        if($settings['spin_text'] == 'spin'){

            $ts = TextSpinner::getInstance();

            $desctoimport = $ts->spin($desctoimport, $settings['spin_text_words']);

        }*/

		$desctoimport='';
		$excerpt='';
		$productTitle = strip_tags($additionalInfo['productTitle']);
        $post = array(

            'post_title'   => $productTitle,

            'post_content' => $desctoimport,

            'post_status'  => $pstatus,

            'post_excerpt' => $excerpt,

            'post_name'    => self::slugify($productTitle), //name/slug

            'post_type'    => "product"

        );



        // Create product/post:

        $new_post_id = wp_insert_post($post);

        if (intval($cat) <= 0 && isset($prod->categoryName)) {
			
            $parent_term = term_exists(trim(htmlspecialchars($prod->categoryName)), 'product_cat' ); // array is returned if taxonomy is given

            if (is_null($parent_term) || !isset($parent_term["term_id"]))

            {

                $term = wp_insert_term(trim($prod->categoryName),  'product_cat', array('description'=> '','slug' => str_replace(' ','', trim($prod->categoryName))));

                if(!is_null($term) && isset($term["term_id"])) {

                    $cat =  $term["term_id"];

                }

            }

            else {

                $cat = $parent_term["term_id"];

            }

        }

		if(intval($cat) > 0) {

            wp_set_object_terms($new_post_id, intval($cat), 'product_cat');

        }

        //wp_set_object_terms($new_post_id, $prod->keywords, 'product_tag', true);



        $i = 0;

        $product_attributes = array();

       // foreach($prod->attribute as $att=>$v) {
		   foreach($additionalInfo as $att=>$v) {

            $product_attributes[$i] = array (

                //'name' => htmlspecialchars( stripslashes( $v->name ) ), // set attribute name

                //'value' => $v->value, // set attribute value

                'position' => 1,

                'is_visible' => 1,

                'is_variation' => 1,

                'is_taxonomy' => 0

            );



            $i++;

        }

        if (count($product_attributes)>0)

            update_post_meta($new_post_id, '_product_attributes', $product_attributes);



        $conversionRate = floatval($settings['conversion_rate']);



        $regularPrice = Helpers::formatPrice($additionalInfo['originalPrice'], $additionalInfo['lotNum'], $conversionRate);

        $salePrice = Helpers::formatPrice($additionalInfo['salePrice'], $additionalInfo['lotNum'], $conversionRate);

        $price = null;



        if($salePrice == $regularPrice) {

            $salePrice = '';

            $price = $regularPrice;

        } else {

            $price = $salePrice;

        }



        update_post_meta($new_post_id, '_stock_status', /*$post->availability == true ? */'instock' /*: 'outofstock'*/);

        update_post_meta($new_post_id, '_weight', "" );

        update_post_meta($new_post_id, '_sku', $additionalInfo['productId']);

        update_post_meta($new_post_id, '_stock', "100" );

        update_post_meta($new_post_id, '_visibility', 'visible' );

        update_post_meta($new_post_id, '_ali_id', $additionalInfo['productId']);

        update_post_meta($new_post_id, '_regular_price', $regularPrice);

        update_post_meta($new_post_id, '_sale_price', $salePrice);

        update_post_meta($new_post_id, '_price', $price);



        update_post_meta($new_post_id, '_downloadable', 'no');

        update_post_meta($new_post_id, '_virtual', 'no');

        update_post_meta($new_post_id, '_backorders', 'no');

        update_post_meta($new_post_id, '_manage_stock', 'no');



        $detailUrl = str_replace('http://s.click.aliexpress.com/e/', '', $additionalInfo['productUrl']);

        $detailUrl = home_url('/?redirectAli='.$additionalInfo['productUrl']);



        update_post_meta($new_post_id, '_product_url', $detailUrl);



        //return;



        wp_set_object_terms ($new_post_id, 'external', 'product_type');

        require_once( ABSPATH . 'wp-admin/includes/admin.php' );

        require_once(ABSPATH . 'wp-admin/includes/file.php');

        require_once(ABSPATH . 'wp-admin/includes/media.php');

        $thumb_url = $additionalInfo['imageUrl'];//$prod->imageUrl;
	
        $tmp = download_url( $thumb_url );
        if ( is_wp_error( $tmp ) ) {

			//

        }



        preg_match('/[^\?]+\.(jpg|JPG|jpe|JPE|jpeg|JPEG|gif|GIF|png|PNG)/', $thumb_url, $matches);

        $file_array['name'] = basename($matches[0]);

         $file_array['tmp_name'] = $tmp;



        if ( is_wp_error( $tmp ) ) {

            @unlink($file_array['tmp_name']);

            $file_array['tmp_name'] = '';

            //$logtxt .= "Error: download_url error - $tmp\n";

        }

        else{

            //$logtxt .= "download_url: $tmp\n";

        }

		 $thumbid = media_handle_sideload( $file_array, $new_post_id, 'gallery desc' );

        if ( is_wp_error($thumbid) ) {

            @unlink($file_array['tmp_name']);

            $file_array['tmp_name'] = "";

        }

        else{

            set_post_thumbnail($new_post_id, $thumbid);

        }



        require_once(ABSPATH . "wp-admin" . '/includes/image.php');

        $imgs = array();

        /*if($prod->subImageUrl)
        foreach($prod->subImageUrl as $value)

        {

            $thumb_url2 = $value;

            // Download file to temp location

            $tmp2 = download_url( $thumb_url2 );

            preg_match('/[^\?]+\.(jpg|JPG|jpe|JPE|jpeg|JPEG|gif|GIF|png|PNG)/', $thumb_url2, $matches);

            $file_array2['name'] = basename($matches[0]);

            $file_array2['tmp_name'] = $tmp2;



            if ( is_wp_error($tmp2) )

            {

                @unlink($file_array2['tmp_name']);

                $file_array2['tmp_name'] = "";

                continue;

            }



            $imgID = media_handle_sideload( $file_array2, $new_post_id, 'desc' );

            //$logtxt .= "ThumbID2: $imgID\n";



            if ( is_wp_error($imgID) )

            {

                @unlink($file_array2['tmp_name']);

                $file_array2['tmp_name'] = '';

                continue;

            }

            else

            {

                if ($imgID>0)

                    $imgs[] = $imgID;

            }

        }
        */


        if (count($imgs)>0)

            update_post_meta( $new_post_id, '_product_image_gallery', implode(',', $imgs));

        return true;

    }

}

if(class_exists("XpressstoresTemplate_Admin") == false) {


    class XpressstoresTemplate_Admin


    {


        private static $_initialized = false;





        public static function init() {


            if(false == self::$_initialized) {


                self::$_initialized = true;


                self:: initHooks();


            }


        }





        public static function loadResources($hook) {


            if (strpos($hook, 'post') === false) {


                return;


            }





            // css


            wp_enqueue_style('xpressstores_wp_admin_template_css', plugins_url('css/admin-template.css', __FILE__));





            // js


            wp_enqueue_script('xpressstores_wp_admin_template_js_datatables', plugins_url('js/jquery.dataTables.min.js', __FILE__));


            wp_enqueue_script('xpressstores_wp_admin_template_js', plugins_url('js/xpressstores-template.js', __FILE__));


        }





        public static function productsSearchCallback() {


            $items = array();


            $productName = trim($_POST["productName"]);


            if(strlen($productName) != 0) {


                $productName = "%" . $productName . "%";


                $items = self::fetchItems($productName);

            }

            $data = array(


                items => $items


            );





            echo(json_encode($data));


            die();


        }





        private static function initHooks() {


            add_action('admin_enqueue_scripts', array('XpressstoresTemplate_Admin', 'loadResources') );


            add_action('wp_ajax_xpressstores_template_products_search', array('XpressstoresTemplate_Admin', 'productsSearchCallback'));


        }





        private static function fetchItems($productName) {


            global $wpdb;


            $items = $wpdb->get_results($wpdb->prepare("


                    SELECT id, guid, post_title as postTitle


                    FROM {$wpdb->posts} as p


                      INNER JOIN {$wpdb->postmeta} as pm ON p.ID = pm.post_id AND pm.meta_key = '_ali_id'


                    WHERE p.post_type = 'product' AND


                          p.post_title like %s",


                $productName));





            for($i = 0; $i < count($items); $i++) {


                $item = $items[$i];


                $item->link = '<a target="_blank" href="'.$item->guid.'">'.substr($item->postTitle, 0, 100).'</a>';


                $item->image = get_the_post_thumbnail($item->id, array( 100, 100));


            }
            return $items;

        }


    }


}
