    /*jslint browser: true*/
    /*global $, jQuery, ajaxurl, alert, console*/

var AFTemplate;

if(!AFTemplate) {
    AFTemplate = {};
}

(function () {
    var oTable,
        $container,
        $productName,
        $search;

    function clearProducts() {
        oTable.fnClearTable();
    }

    function addProducts(items) {
        //console.log(items);
        oTable.fnAddData(items);
    }

    function search(e) {
        e.preventDefault();

        if($productName.val() == '') {
            alert("'Product Name' is a required field.");
        } else {
            var $button = jQuery(this);
            $button.hide();
            clearProducts();

            jQuery.ajax({
                type: 'post',
                url: ajaxurl,
                data: {
                    action: 'xpressstores_template_products_search',
                    productName: $productName.val()
                },
                dataType: 'json',
                cache: false
            }).done(function (data) {
                addProducts(data.items);
            }).fail(function (jqXHR, textStatus) {
                console.log('jqXHR', jqXHR);
                console.log('textStatus', textStatus);
                alert('Search failed.')
            }).always(function () {
               $button.show();
            });
        }
    }

    function generateShortCode(templateId, productId) {
        return '[xpressstores_template template=' + templateId + ' productId=' + productId + ']';
    }

    function applyJQueryEvents() {
        $container = jQuery('.alimetabox');
        $productName = $container.find('#af-product-name');
        $search = $container.find('#af-button-search');

        $search.on('click', search);
        $container.on('click', '.import-link', function (e) {
            e.preventDefault();

            var productId = jQuery(this).data('productid'),
                templateId = $container.find('#af-template-type').val();
                shortCode = generateShortCode(templateId, productId);

            send_to_editor(shortCode);
        });

        oTable = $container.find('#af-products').dataTable({
            'filter': false,
            'info': false,
            'lengthChange': false,
            'columns': [
                { data: 'id', width: '50px' },
                {
                    orderable: false,
                    data: null,
                    render: function (data, type, full, meta) {
                        return full.image
                    }
                },
                //{ data: 'postTitle' },
                {
                    data: null,
                    render: function (data, type, full, meta) {
                        return full.link
                    }
                },
                {
                    orderable: false,
                    data: null,
                    render: function (data, type, full, meta) {
                        return '<button class="import-link button" data-productid="' + full.id + '">Insert Link</button>'
                    }
                }
            ]
        });
    }

    function init() {
        applyJQueryEvents();
    }

    if(typeof AFTemplate.init !== 'function') {
        AFTemplate.init = function () {
            init();
        }
    }
}());