    /*jslint browser: true*/
    /*global $, jQuery, ajaxurl, alert, console, importedAliIds*/


var AFImport;
if (!AFImport) {
    AFImport = {};
}

(function () {
    "use strict";
    var $container,
        $table,
        $filter,
        $keywords,
        $loader,
        $results,
        $pager,
        $pagerCurrent,
        $form,
        $categories,
        $importButton,
        $importBulkButton,
        $formAuto,
        $showingResults,
        $importing,
        $circle,
//non-jquery variables
        oTable,
        page,
        total,
        auto,
        bulk,
        animationStartValue,
        numTotalToImport,
        numImported,
        numFailed;
    
    
    function clearData() {
        oTable.fnClearTable();
    }
    
    function refreshTable(data) {
		
        clearData();
        
        if (typeof data.result !== 'undefined' && data.result.totalResults > 0) {
            if (auto === false) {
                $importButton.removeClass('hidehtml');
            }
            $pager.parent().removeClass('hidehtml');
            
            oTable.fnAddData(data.result.products);
            total = data.result.totalResults;
            $pagerCurrent.text(page);
            
            var length = data.result.products.length,
                showingFrom = (((page - 1)  * length) + 1),
                showingTo = page * length;

            if (bulk === false) {                
                $showingResults.show().text('Showing ' + showingFrom + '-' + showingTo  + ' of ' + data.result.totalResults);               
            }
            else
            {
                $showingResults.show().text(data.result.totalResults); 
                $results.removeClass('hidehtml');
            }
        } else {
            page = 0;
            total = 0;
            if (auto === false) {
                $importButton.addClass('hidehtml');
            }
            $pager.parent().addClass('hidehtml');
            $showingResults.hide();
        }
        $loader.addClass('hidehtml');
    }
    
    function getData(data) {
		
        jQuery.ajax({
            type: 'POST',
            url: ajaxurl,
            data: data,
            dataType: 'json',
            cache: false
        }).done(function (data) {
			//console.log(data);
            refreshTable(data);
        }).fail(clearData)
		
    }
    
    function search() {
        $loader.removeClass('hidehtml');
        var data = {
            action: 'aliexpress_json',
            pageNo: page,
            keywords: $filter.find('#keywords').val(),
            categoryId: $filter.find('#category-id').val(),
            originalPriceFrom: $filter.find('#price-from').val() || 0,
            originalPriceTo: $filter.find('#price-to').val() || "",
            commissionRateFrom: $filter.find('#commission-rate-from').val() || 0,
            commissionRateTo: $filter.find('#commission-rate-to').val() || "",
            volumeFrom: $filter.find('#sales-from').val() || 0,
            volumeTo: $filter.find('#sales-to').val() || ""
        };
        getData(data);
    }
    
    function scrollToTop() {
        jQuery('html, body').animate({ scrollTop: 0 }, 1000);
    }
    
    function onlyNumbers(e) {
        // Allow: backspace, delete, tab, escape, enter and .
        if (jQuery.inArray(e.keyCode, [46, 8, 9, 27, 13, 110, 190]) !== -1 ||
                // Allow: Ctrl+A
                (e.keyCode === 65 && e.ctrlKey === true) ||
                // Allow: home, end, left, right
                (e.keyCode >= 35 && e.keyCode <= 39)) {
                 // let it happen, don't do anything
            return;
        }
        // Ensure that it is a number and stop the keypress
        if ((e.shiftKey || (e.keyCode < 48 || e.keyCode > 57)) && (e.keyCode < 96 || e.keyCode > 105)) {
            e.preventDefault();
        }
    }
    
    function openImportingOverlay() {
        animationStartValue = 0;
        $importing.dialog({
            modal: true,
            width: 250,
            open: function (event, ui) {
                jQuery(".ui-widget-header").hide();
            }
        });
    }
    
    function closeImportingOverlay() {
        $importing.dialog('close');
        $circle.circleProgress({ value: 0 });
    }
    
    function updateImportingProgress(value) {
        $circle.circleProgress({
            animationStartValue: animationStartValue,
            value: value
        });
        
        animationStartValue = value;
    }
    
    function importProducts(data, openOverlay) {
        if (openOverlay) {
            numImported = 0;
            numFailed = 0;

            var $checkboxes = $results.find('input[type="checkbox"].import:checked');
            $checkboxes.removeClass('skip');
            numTotalToImport = $checkboxes.length;
            openImportingOverlay();
        }
        
        var $item = $results.find('input[type="checkbox"].import:not(.skip):checked:first'),
            iPos,
            aData,
            products = [];
        
        if ($item.length > 0) {
            iPos = oTable.fnGetPosition($item.closest('tr').get(0));
            aData = oTable.fnGetData(iPos);
            products.push(aData);
            
            // post
            jQuery.ajax({
                type: 'POST',
                url: ajaxurl,
                data: jQuery.extend({}, data, {products: products}),
                dataType: 'json',
                cache: false
            }).done(function (data) {
                if (data.Executed === true) {
                    importedAliIds.push(aData.productId);
                    $item
                        .parent()
                            .addClass('imported')
                            .end()
                        .remove();
                }
            }).fail(function (jqXHR, textStatus) {
                console.log("import failed!");
                console.log(jqXHR);
                console.log(textStatus);              
                $item.addClass('skip');
                numFailed++;
            }).always(function () {
                numImported = numImported + 1;
                updateImportingProgress((numImported / numTotalToImport).toFixed(2));
                importProducts(data);
            });
        } else {
            $results.find('input[type="checkbox"].all').removeAttr('checked');
            setTimeout(closeImportingOverlay, 2000);

            if(numFailed != 0) {
                alert(numFailed.toString() + ' product(s) failed to import.');
            }
        }
    }

    function bulkImportProducts(data, openOverlay) {
        if (openOverlay) {
            numImported = 0;
            numTotalToImport = $results.find('#numtoinsert').val();
            openImportingOverlay();
        }
        // post
        jQuery.ajax({
            type: 'POST',
            url: ajaxurl,
            data: data, 
            dataType: 'json',
            cache: false
        }).done(function (d) {
            if (d.Executed === true) {
                //importedAliIds.push(aData.productId);
                data["toinsert"] = data["toinsert"]-d.Added;  
                numImported = numImported + d.Added;
                updateImportingProgress((numImported / numTotalToImport).toFixed(2)); 
                
                data["pageNo"] = data["pageNo"]+1;
                               
                if (d.Finished === true)
                {
                    setTimeout(closeImportingOverlay, 2000);      
                }
                else
                {
                    bulkImportProducts(data);
                }
                console.log(d);                
            }
        }).fail(function (jqXHR, textStatus) {
            console.log("import failed!");
            console.log(jqXHR);
            console.log(textStatus);
            //setTimeout(closeImportingOverlay, 2000); 
            if (numImported < numTotalToImport)
            {
                bulkImportProducts(data);
            }
        }).always(function () {
            //numImported = numImported + 1;
            //updateImportingProgress((numImported*40 / numTotalToImport).toFixed(2));
           
        });      
        
    }

    function applyJQueryEvents() {
        var visiblefirst = auto !== true;
        oTable = $table.dataTable({
            "paging": false,
            "ordering": false,
            "info": false,
            "filter": false,
            "columns": [
                {
                    "visible": visiblefirst,
                    "sortable": false,
                    "class":          '',
                    "orderable":      false,
                    "data":           null,
                    render: function (data, type, full, meta) {
                        if (visiblefirst) {
                            if (importedAliIds.indexOf(full.productId.toString()) !== -1) {
                                return '<div class="import imported"></div>';
                            } else {
                                return '<div class="import">' +
                                        '<input type="checkbox" class="import" data-productid="' + full.productId + '" />' +
                                        '</div>';
                            }
                        } else {
                            return '';
                        }
                    }
                },
                {
                    render: function (data, type, full, meta) {
                        return '<img src="' + full.imageUrl + '" />';
                    },
                    "sortable": false,
                    "class":          '',
                    "orderable":      false,
                    "data":           null,
                    "defaultContent": ''
                }, 
                //{
                //    render: function (data, type, full, meta) {
                //        return '<a target="_blank" href="' + full.detailUrl + '">'+full.subject+'</a>';
                //    },
                //    sortable: false,
                //    "class":          '',
                //    "orderable":      false,
                //    "data":           null,
                //    "defaultContent": ''
                //}, 
                { "data": "productTitle" }, 
                {
                    "data": "salePrice"
                },
                { "data": "volume" },
                { "data": "packageType" },
                { "data": "lotNum" },
				{ "data": "30daysCommission" },
                //{
                    //render: function (data, type, full, meta) {
                        //return parseFloat(full["30daysCommission"]).toFixed(1);
                   // },
                   // "data": null
               // }
            ]
        });
              
        $filter.find('#search').on('click', function () {
            page = 1;
            if (auto) {
                if ($formAuto.valid()) { search();  }
            } else {
                if ($form.valid()) { search();  }
            }
           
        });

        $importBulkButton.on('click', function () {
           var data = {
                action: 'xpressstores_bulk',
                toinsert: $container.find('#numtoinsert').val() || 0,
                aiCategory: $container.find('#aiCategory').val() || 0,
				keywords: $filter.find('#keywords').val(),
				categoryId: $filter.find('#category-id').val(),
				originalPriceFrom: $filter.find('#price-from').val() || 0,
				originalPriceTo: $filter.find('#price-to').val() || "",
				commissionRateFrom: $filter.find('#commission-rate-from').val() || 0,
				commissionRateTo: $filter.find('#commission-rate-to').val() || "",
				volumeFrom: $filter.find('#sales-from').val() || 0,
				volumeTo: $filter.find('#sales-to').val() || "",
                pageNo: 1
            };
			
            bulkImportProducts(data, true);
           
        });
        $filter.find('#save').on('click', function () {           
                if ($formAuto.valid()) { }                      
        });
        $pager.find('.previous').on('click', function () {
            if (total !== 0 && page > 1) {
                page = page - 1;
                search();
            }
            if (jQuery(this).hasClass('bottom')) {
                scrollToTop();
            }
        });
        $pager.find('.next').on('click', function () {
            if (total !== 0 && page < total) {
                page = page + 1;
                search();
            }
            if (jQuery(this).hasClass('bottom')) {
                scrollToTop();
            }
        });
        $form.validate({
            onkeyup: false,
            rules: {
                categoryId: {
                    required: {
                        depends: function () {
                            return $keywords.val() === '';
                        }
                    }
                },
                keywords: {
                    required: {
                        depends: function () {
                            return $categories.val() === '';
                        }
                    }
                },
                priceFrom: {
                    number: true
                },
                priceTo: {
                    number: true
                },
                commissionRateFrom: {
                    number: true
                },
                commissionRateTo: {
                    number: true
                },
                salesFrom: {
                    number: true
                },
                salesTo: {
                    number: true
                }
            },
            errorPlacement: function (error, element) {
                var $element = jQuery(element);
                if ($element.is('input')) {
                    $element.val('');
                }
            }
            
        });
        $formAuto.validate({
            onkeyup: false,
            rules: {
                aiAliCategory: {
                    required: {
                        depends: function () {
                            return $keywords.val() === '';
                        }
                    }
                },
                aiKeyword: {
                    required: {
                        depends: function () {
                            return $categories.val() === '' || $categories.val() == '0';
                        }
                    }
                },
                aiPriceFrom: {
                    number: true
                },
                aiPriceTo: {
                    number: true
                },
                aiCommisionFrom: {
                    number: true
                },
                aiCommisionTo: {
                    number: true
                },
                aiSalesFrom: {
                    number: true
                },
                aiSalesTo: {
                    number: true
                }
            },
            errorPlacement: function (error, element) {
                var $element = jQuery(element);
                if ($element.is('input')) {
                    $element.val('');
                }
            }
            
        });
        $categories.on('change', function () {
            $keywords.removeClass('error');
        });
        $keywords.on('change', function () {
            $categories.removeClass('error');
        });
        $filter.find('input.number')
            .on('keydown', onlyNumbers)
            .on('cut copy paste', function (e) { e.preventDefault(); });
        $importButton.on('click', function () {
            //alert(bulk);
            var data = {
                action: 'xpressstores_import',
                aiCategory: $container.find('#aiCategory').val() || 0
            };
            importProducts(data, true);
        });
        $circle.circleProgress({
            value: 0,
            fill: { gradient: ['#0681c4', '#07c6c1'] }
        })
            .on('circle-animation-progress', function (event, progress, stepValue) {
                jQuery(this).find('strong').text(String((stepValue * 100).toFixed(0)) + '%');
            });
    }
    
    function init(options) {
        var defaults = {
            auto: false,
            bulk: false
        },
            settings = jQuery.extend({}, defaults, options);

        auto = settings.auto;
        bulk = settings.bulk;

        $container = jQuery('.wrapper');
        $table = $container.find('#results.data-table');
        $filter = $container.find('#filter');
        $loader = $container.find('#loader');
        $results = $container.find('.results');
        $pager = $results.find('.pager');
        $pagerCurrent = $pager.find('.current');
        $importButton = $results.find('#import');
        $importBulkButton = $results.find('#importbulk');        
        $form = $container.find('#xpressstores-search-form');
        $formAuto = $container.find('#xpressstores-auto-form');
        $categories = $filter.find('#category-id');
        $keywords = $filter.find('#keywords');
        $showingResults = $results.find('#showing-results');
        $importing = $container.find('#importing');
        $circle = $importing.find('.circle');
        
        applyJQueryEvents();
    }
    
    
    /* PUBLIC */
    if (typeof AFImport.init !== 'function') {
        AFImport.init = function (options) {
            init(options);
        };
    }
}());