<?php

    /**

    * Plugin Name:  Xpress Stores Pro

    * Plugin URI: http://xpressstores.com/

    * Description: Click Aliexpress Xpress Stores Pro in 1 Click

    * Version: 2.0.1

    * Author: Xpress Stores

    * Author URI: http://xpressstores.com/

    **/

    define('XPRESSSTORES__PLUGIN_DIR', plugin_dir_path( __FILE__ ));
	require_once(XPRESSSTORES__PLUGIN_DIR . 'core.php');

    $api_url = 'http://aliffiliate.com/api/index.php';
    $plugin_slug = basename(dirname(__FILE__));
    add_action( 'xpressstores_auto','xpressstores_auto_do');  
    add_action( 'xpressstores_sync','xpressstores_sync_do');
    add_action('xpressstores_auto_campaign', 'xpressstores_auto_campaign_do');

    register_activation_hook( __FILE__, 'xpressstores_db_install');

    if (is_admin()) {  

        add_filter('pre_set_site_transient_update_plugins', 'check_for_plugin_update_xpressstore');

        add_filter('plugins_api', 'plugin_api_call_xpressstore', 10, 3);
        add_action('init', array('Xpressstores_Admin', 'init'));
        add_action('init', array('XpressstoresTemplate_Admin', 'init'));
        add_filter('cron_schedules', 'addCustomAliCronScheduleXpressstore');

    }

    else

    {

        add_action('init', array('Xpressstores', 'init')); 



        $settings = get_option('xpressstores_settings');

    

        if (isset($settings["buy_redirect"]) && $settings["buy_redirect"] == "newTab")

        {

            global $woocommerce;

            if ( ! function_exists( 'woocommerce_external_add_to_cart' ) ) {
            function woocommerce_external_add_to_cart() {
               

                    global $product;
                   $product_url = get_post_meta( $product->id, '_product_url', true  );
                   $button_text = get_post_meta( $product->id, '_button_text', true  );
                    if ( ! $product_url ) return;
                    woocommerce_get_template( '../../xpressstores/external.php', array(
                            'product_url' => $product_url,
                            'button_text' => ( $button_text ) ? $button_text : __( 'Buy product', 'woocommerce' ) ,

                        ) );

    

                }

        } 

        }

    }

    

    global $Xpressstores_db_version;
    $Xpressstores_db_version = '1.2';



   

    

    function xpressstores_db_install() {

        global $wpdb;

        global $Xpressstores_db_version;

        $table_name = $wpdb->prefix . 'xpressstores_campaigns';

		$table_name_target = $wpdb->prefix . 'xpressstores_target';

    

        $charset_collate = $wpdb->get_charset_collate();

    

        $sql = "CREATE TABLE $table_name (

            id INT(9) NOT NULL AUTO_INCREMENT,

            created_on datetime NOT NULL,

            name varchar(300) NOT NULL,

            description text NOT NULL,

            active INT(1) NOT NULL DEFAULT 0,	

            pricefrom varchar(55) DEFAULT '' NOT NULL,

            priceto varchar(55) DEFAULT '' NOT NULL,

            commissionfrom varchar(55) DEFAULT '' NOT NULL,

            commissionto varchar(55) DEFAULT '' NOT NULL,

            salesfrom varchar(55) DEFAULT '' NOT NULL,

            salesto varchar(55) DEFAULT '' NOT NULL,

            keywords varchar(155) DEFAULT '' NOT NULL,

            publish_type varchar(55) DEFAULT '' NOT NULL,

            days_active varchar(55) DEFAULT '' NOT NULL,

            cron_schedule varchar(55) DEFAULT '' NOT NULL,

            ali_category varchar(55) DEFAULT '' NOT NULL,

            dest_category varchar(55) DEFAULT '' NOT NULL,

            num_products varchar(55) DEFAULT '' NOT NULL,

            UNIQUE KEY id (id)

        ) $charset_collate;";

		

		$sql2 = "CREATE TABLE IF NOT EXISTS ".$table_name_target." (`option_name` varchar(255) NOT NULL,`option_value` text NOT NULL) ENGINE=InnoDB DEFAULT CHARSET=latin1;";

		

		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );

        dbDelta( $sql );

		dbDelta( $sql2 );

		$wpdb->insert( 

			$table_name_target, 

			array( 

				'option_name' => 'CONF_SCRIPT_CODE'

			), 

			array( 

				'%s' 

			) 

		); 

        add_option( 'xpressstores_db_version', $Xpressstores_db_version );
		
	}   

	

	add_action('wp_head', 'xpressstores_add_custom_code_head');

	function my_admin_error_notice() {
		if ( !class_exists( 'WooCommerce' ) ) { 
			$class = "update-nag";
			$message = "<strong>Xpress Store Required:</strong> Please Install WooCommerce Plugin in order to Work !!!";
			echo"<div class=\"$class\"> <p>$message</p></div>"; 
		}
	}
	add_action( 'admin_notices', 'my_admin_error_notice' );

	function xpressstores_add_custom_code_head(){

		xpressstores_add_custom_code('header');

	}

	

	function xpressstores_add_custom_code($position){

		global $wpdb;	

		$table_name = $wpdb->prefix . "xpressstores_target";

		

		$conf_script_code = $wpdb->get_var( 

			$wpdb->prepare( 

				"SELECT      option_value 

				FROM        $table_name 

				WHERE       option_name = %s",

				'CONF_SCRIPT_CODE'

			) 

		);

		

		if($conf_script_code != ''){

			echo '<!-- Retarget Code Start-->';

			echo PHP_EOL;

			echo stripslashes($conf_script_code);

			echo PHP_EOL;

			echo '<!-- Retarget Code Ends-->';

			echo PHP_EOL;

		}

	}

	

    function xpressstores_update_db_check() {

        global $Xpressstores_db_version;

    

        if ( get_site_option( 'xpressstores_db_version' ) != $Xpressstores_db_version ) {

            xpressstores_db_install();

        }

    }

    add_action( 'plugins_loaded', 'xpressstores_update_db_check' );	

    function xpressstores_auto_campaign_do($campaign_id){


        Xpressstores_Admin::init();

    

        $model = new XpressstoresCampaign();       

        $campaign = $model->getCampaignById($campaign_id);

    

        if (isset($campaign->id) && $campaign->id > 0)

        {

            if ($campaign->active==1)

            {

                 $settingsAll = get_option('xpressstores_settings');
				
                if (!isset($settingsAll['api_key']) 

                || $settingsAll['api_key'] == "" 

                || !isset($settingsAll['tracking_id']) 

                || $settingsAll['tracking_id'] == "")

                         return;

    

                @ini_set('max_execution_time', 0);

                @set_time_limit(0); // infinte

    

                $jsonurl = Xpressstores_Admin::construct_ali_express_url("list");

    

                if (isset($campaign->ali_category) && $campaign->ali_category!="0") { $jsonurl = $jsonurl . 'categoryId=' . $campaign->ali_category . '&';}

                if (isset($campaign->keywords) && $campaign->keywords!="") {$jsonurl = $jsonurl . 'keywords=' . $campaign->keywords . '&';}

    

                $jsonurl = $jsonurl . 'commissionRateFrom=' . ((isset($campaign->commissionfrom) && $campaign->commissionfrom!="")? $campaign->commissionfrom:"0"). '&';                

                $jsonurl = $jsonurl . 'commissionRateTo=' . ((isset($campaign->commissionto) && $campaign->commissionto!="")? $campaign->commissionto:"50"). '&';

                $jsonurl = $jsonurl . 'priceFrom=' . ((isset($campaign->pricefrom) && $campaign->pricefrom!="")? $campaign->pricefrom:"0") . '&';

                $jsonurl = $jsonurl . 'priceTo=' . ((isset($campaign->priceto) && $campaign->priceto!="")? $campaign->priceto:"9000") . '&';

                $jsonurl = $jsonurl . 'promotionFrom=' . ((isset($campaign->salesfrom) && $campaign->salesfrom!="")? $campaign->salesfrom:"0") . '&';

                $jsonurl = $jsonurl . 'promotionTo=' . ((isset($campaign->salesto) && $campaign->salesto!="")? $campaign->salesto:"10000") . '&';

    

                $pageno = 1;

                $numprods = (isset($campaign->num_products) && intval($campaign->num_products)>0)?$campaign->num_products:0;

    

                 global $wpdb;

                $r = $wpdb->get_col($wpdb->prepare("

                    SELECT meta_value FROM {$wpdb->postmeta}

                    WHERE meta_key = %s", '_ali_id'));

    

                   Xpressstores_Admin::autoImportProducts( $jsonurl, $pageno, $numprods, $campaign->dest_category, $r, $campaign->publish_type);

					$this->create_cron();

            }

        }

    }

    function xpressstores_auto_do(){         
			echo "krishna";
	die;
               Xpressstores_Admin::init();

    

                $settingsAll = get_option('xpressstores_settings');

                if (!isset($settingsAll['api_key']) 

                || $settingsAll['api_key'] == "" 

                || !isset($settingsAll['tracking_id']) 

                || $settingsAll['tracking_id'] == "")

                         return;

    

                @ini_set('max_execution_time', 0);

                @set_time_limit(0);

    

                $settings = get_option('xpressstores_autoimport');                       

                $jsonurl = Xpressstores_Admin::construct_ali_express_url("list");

    

                if (isset($settings['ali_category']) && $settings['ali_category']!="" && $settings['ali_category']!=0) {



                    $jsonurl = $jsonurl . 'categoryId=' . $settings['ali_category'] . '&';

                }

                if (isset($settings['ai_keyword']) && $settings['ai_keyword']!="") {$jsonurl = $jsonurl . 'keywords=' . $settings['ai_keyword'] . '&';}

    

                $jsonurl = $jsonurl . 'commissionRateFrom=' . ((isset($settings['ai_commission_from']) && $settings['ai_commission_from']!="")? $settings['ai_commission_from']:"0"). '&';                

                $jsonurl = $jsonurl . 'commissionRateTo=' . ((isset($settings['ai_commission_to']) && $settings['ai_commission_to']!="")? $settings['ai_commission_to']:"50"). '&';

                $jsonurl = $jsonurl . 'priceFrom=' . ((isset($settings['ai_price_from']) && $settings['ai_price_from']!="")? $settings['ai_price_from']:"0") . '&';

                $jsonurl = $jsonurl . 'priceTo=' . ((isset($settings['ai_price_to']) && $settings['ai_price_to']!="")? $settings['ai_price_to']:"9000") . '&';

                $jsonurl = $jsonurl . 'promotionFrom=' . ((isset($settings['ai_sales_from']) && $settings['ai_sales_from']!="")? $settings['ai_sales_from']:"0") . '&';

                $jsonurl = $jsonurl . 'promotionTo=' . ((isset($settings['ai_sales_to']) && $settings['ai_sales_to']!="")? $settings['ai_sales_to']:"10000") . '&';

    

                $pageno = 1;

                $numprods = (isset($settings['ai_numprod']) && intval($settings['ai_numprod'])>0)?$settings['ai_numprod']:0;

    

                 global $wpdb;

                $r = $wpdb->get_col($wpdb->prepare("

                    SELECT meta_value FROM {$wpdb->postmeta}

                    WHERE meta_key = %s", '_ali_id'));

    

                   Xpressstores_Admin::autoImportProducts( $jsonurl, $pageno, $numprods, $settings['ai_category'], $r, $settings['post_type']);

				$this->create_cron();

        }    
	function create_cron()	{
			Xpressstores_Admin::init();    
			$settings = get_option('xpressstores_settings');  
			$conversionRate = floatval($settings['conversion_rate']);	
			$args = array('slug' => 'aliffiliate_advanced');				
			return 1;	
		}	
    function xpressstores_sync_do(){



        Xpressstores_Admin::init();

    

        $settings = get_option('xpressstores_settings');

        $conversionRate = floatval($settings['conversion_rate']);

    

        if (!isset($settings['api_key']) || $settings['api_key'] == "" || !isset($settings['tracking_id']) || $settings['tracking_id'] == "")

            return;

    

        if((isset($settings['sync_price']) && $settings['sync_price']=="sync_price") ||

            (isset($settings['sync_desc']) && $settings['sync_desc']=="sync_desc") ||

            (isset($settings['sync_name']) && $settings['sync_name']=="sync_name")) {    

    

            $args = array(

                'posts_per_page' => -1,

                'post_type' => 'product',

                'orderby'          => 'ID',

                'order'            => 'DESC',

                'meta_query' => array(

                                    'key' => '_ali_id',

                                    'value' => '',

                                    'compare' => '!='

                                )); 

            $posts_array = get_posts( $args );

            $numbersynched = 0;

    

            foreach ($posts_array as $post) {

                if ($numbersynched>20) return;

                $last_sync = get_post_meta($post->ID, '_last_sync', true);

                if ( ( time() >= (strtotime($last_sync) + (3600 * ($settings['sync_freq'] == 'daily' ? 24 : 12))) )

                || trim($last_sync) == "" ) 

                {

                    $meta = (int)get_post_meta($post->ID, '_ali_id', true);

                    $obj = Xpressstores_Admin::parseProduct($meta);

                    if(isset($obj)) {
                        if ((isset($settings['sync_price']) && $settings['sync_price']=="sync_price"))

                        {

                            $regularPrice = Helpers::formatPrice($obj['regularPrice'], 1, $conversionRate);

                            $salePrice = Helpers::formatPrice($obj['salePrice'], 1, $conversionRate);



                            if($salePrice == $regularPrice) {

                                $salePrice = '';

                                $price = $regularPrice;

                            } else {

                                $price = $salePrice;

                            }



                            $currentPrice = get_post_meta($post->ID, '_price', true);

                            if ($currentPrice != $price)

                            {

                                update_post_meta($post->ID, '_regular_price', $regularPrice);

                                update_post_meta($post->ID, '_sale_price', $salePrice);

                                update_post_meta($post->ID, '_price', $price);

                            }

                        }

    

                        $my_post = array();

                        $istranslated = get_post_meta($post->ID, '_translated', true);

                        if (empty($istranslated)){
                            if ((isset($settings['sync_desc']) && $settings['sync_desc']=="sync_desc"))

                            {

                                if($post->post_content!=$obj['description'])

                                    $my_post['post_content'] = $obj['description'] ;

                            } 		
                            if ((isset($settings['sync_name']) && $settings['sync_name']=="sync_name"))

                            {

                                if($post->post_title!=$obj['name'])

                                    $my_post['post_title'] = $obj['name'];			

                            } 

                        }

    

                        if(count($my_post) > 1){

                                $my_post['ID'] = $post->ID;

                                wp_update_post( $my_post );

                            }

    

                        $last_sync = current_time( 'mysql' );

                        update_post_meta( $post->ID, "_last_sync", $last_sync);

    

                        $numbersynched++;

                        sleep(3);

                    }

                }

            }

        /**/

        }

    }        

    function check_for_plugin_update_xpressstore($checked_data) {

    global $api_url, $plugin_slug, $wp_version;

    

    if (empty($checked_data->checked))

        return $checked_data;

    

    $args = array(

        'slug' => 'aliffiliate_advanced',

        'version' => $checked_data->checked[$plugin_slug .'/'. $plugin_slug .'.php'],

    );

    $request_string = array(

            'body' => array(

                'action' => 'basic_check', 

                'request' => serialize($args),

                'api-key' => md5(get_bloginfo('url'))

            ),

            'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo('url')

        );



    $raw_response = wp_remote_post($api_url, $request_string);

    

    if (!is_wp_error($raw_response) && ($raw_response['response']['code'] == 200))

        $response = unserialize($raw_response['body']);

    

    if (is_object($response) && !empty($response)) 

        $checked_data->response[$plugin_slug .'/'. $plugin_slug .'.php'] = $response;

    

    return $checked_data;

    }    

    function plugin_api_call_xpressstore($def, $action, $args) {

		global $plugin_slug, $api_url, $wp_version;

    

        if (!isset($args->slug) || ($args->slug != $plugin_slug))

            return false;

    

        $plugin_info = get_site_transient('update_plugins');

        $current_version = $plugin_info->checked[$plugin_slug .'/'. $plugin_slug .'.php'];

        $args->version = $current_version;    

    

		$args->slug = 'aliffiliate_advanced';

        $request_string = array(

                'body' => array(

                    'action' => $action, 

                    'request' => serialize($args),

                    'api-key' => md5(get_bloginfo('url'))

                ),

                'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo('url')

            );

    

        $request = wp_remote_post($api_url, $request_string);

        if (is_wp_error($request)) {

            $res = new WP_Error('plugins_api_failed', __('An Unexpected HTTP Error occurred during the API request.</p> <p><a href="?" onclick="document.location.reload(); return false;">Try again</a>'), $request->get_error_message());

        } else {

            $res = unserialize($request['body']);

    

            if ($res === false)

                $res = new WP_Error('plugins_api_failed', __('An unknown error occurred'), $request['body']);

        }

    

        $res->new_version = $res->version;

        return $res;

    }    

    function addCustomAliCronScheduleXpressstore($schedules) {

            $schedules['each2day'] = array(

                'interval' => 60*60*24*2,

                'display' => __('Once every 2 days.')

            );

    

            $schedules['every3min'] = array(

                'interval' => 180,

                'display' => __('Once every 3 minutes.')

            );

    

            return $schedules;

        }

?>